## sfcgal 2.0.0

=== CMakeLists.txt ===
cmake_minimum_required( VERSION 3.6 )
project( SFCGAL )

set( CMAKE_DEBUG_POSTFIX "d" )
set(CMAKE_CXX_STANDARD 17)

# ignore system installed SFCGAL to avoid conflicts during build/edit
list(APPEND CMAKE_IGNORE_PREFIX_PATH "/usr/include/SFCGAL")
list(APPEND CMAKE_IGNORE_PREFIX_PATH "/usr/local/include/SFCGAL")

#
# Cmake policies
#
if(POLICY CMP0077)
    cmake_policy(SET CMP0077 NEW)
endif()

if(POLICY CMP0167)
    cmake_policy(SET CMP0167 NEW)
endif()

#----------------------------------------------------------------------------
# build options
#----------------------------------------------------------------------------

# Windows M_PI
add_compile_definitions(_USE_MATH_DEFINES)

# Set a default build type if none was specified
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to 'Release' as none was specified.")
  set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "RelWithDebInfo")
endif()

option( SFCGAL_BUILD_EXAMPLES "build examples" OFF )
option( SFCGAL_BUILD_TESTS "build unit and regress tests" OFF )
option( SFCGAL_BUILD_BENCH "Build benchmarks" OFF )
option( SFCGAL_BUILD_DOC "Build documentation" OFF )

option( SFCGAL_WITH_OSG "Compile with OpenSceneGraph support" OFF )

# Configure CCache if available
if(NOT MSVC)
  option(USE_CCACHE "Use ccache" ON)
  if (USE_CCACHE)
    find_program(CCACHE_FOUND ccache)
    if(CCACHE_FOUND)
        set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
        set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ccache)
        message(STATUS "ccache found")
    endif(CCACHE_FOUND)
  endif(USE_CCACHE)
endif(NOT MSVC)

#-- include finders and co
set( CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/Modules;${CMAKE_MODULE_PATH}" )

set( SFCGAL_VERSION_MAJOR 2 )
set( SFCGAL_VERSION_MINOR 0 )
set( SFCGAL_VERSION_PATCH 0 )

set( SFCGAL_VERSION "${SFCGAL_VERSION_MAJOR}.${SFCGAL_VERSION_MINOR}.${SFCGAL_VERSION_PATCH}" )

if (CMAKE_CXX_COMPILER MATCHES ".*clang")
    set(CMAKE_COMPILER_IS_CLANGXX 1)
endif ()

#-----------------------------------------------------------
# dependencies
#-----------------------------------------------------------

#-- find CGAL  ---------------------------------------------
if( CGAL_USE_GMPXX )
	add_definitions( "-DCGAL_USE_GMPXX" )
endif()
option( CGAL_USE_AUTOLINK "disable CGAL autolink" OFF )

if( ${CGAL_USE_AUTOLINK} )
	add_definitions( "-DCGAL_NO_AUTOLINK" )
endif()

find_package( CGAL 5.6 COMPONENTS Core REQUIRED )
message( STATUS "CGAL ${CGAL_VERSION} found" )

include_directories( ${CMAKE_BINARY_DIR}/include )

#-- BOOST --------------------------------------------------
option( Boost_USE_AUTO_LINK "boost use autolink" OFF )
set(Boost_USE_DEBUG_RUNTIME OFF)
set(Boost_USE_STATIC_LIBS OFF)
option( Boost_USE_DEBUG_RUNTIME "Use Boost debug runtime" OFF )

if( NOT ${Boost_USE_AUTO_LINK} )
	add_definitions( "-DBOOST_ALL_NO_LIB" )
endif()

option( Boost_USE_STATIC_LIBS "boost use dynamic libraries" OFF )
if( Boost_USE_STATIC_LIBS )
	message( STATUS "Boost_USE_STATIC_LIBS=ON" )
	add_definitions( "-DBOOST_THREAD_USE_LIB" )
else()
	message( STATUS "Boost_USE_STATIC_LIBS=OFF" )
#	add_definitions( "-DBOOST_TEST_DYN_LINK" )
	add_definitions( "-DBOOST_ALL_DYN_LINK" )
endif()

option( Boost_USE_MULTITHREAD "boost use multithread libraries" ON )
if( ${Boost_USE_MULTITHREAD} )
	message( STATUS "Boost_USE_MULTITHREAD=ON" )
else()
	message( STATUS "Boost_USE_MULTITHREAD=OFF" )
endif()

#-- minimalist build allowed with boost version older than 1.48
set( SFCGAL_Boost_COMPONENTS thread system serialization )
#-- unit test
if ( SFCGAL_BUILD_TESTS )
	set( SFCGAL_Boost_COMPONENTS unit_test_framework program_options ${SFCGAL_Boost_COMPONENTS} )
endif()
#-- program_options
if ( SFCGAL_BUILD_TESTS OR SFCGAL_BUILD_EXAMPLES OR SFCGAL_BUILD_OSG )
	set( SFCGAL_Boost_COMPONENTS program_options chrono filesystem timer ${SFCGAL_Boost_COMPONENTS} )
endif()
find_package( Boost COMPONENTS ${SFCGAL_Boost_COMPONENTS} REQUIRED )
if((${Boost_MAJOR_VERSION} EQUAL 1) AND (${Boost_MINOR_VERSION} EQUAL 58))
	message( STATUS "Defining BOOST_VARIANT_USE_RELAXED_GET_BY_DEFAULT" )
	add_definitions( "-DBOOST_VARIANT_USE_RELAXED_GET_BY_DEFAULT" )
endif()

if( SFCGAL_USE_STATIC_LIBS )
  add_definitions( "-DSFCGAL_USE_STATIC_LIBS" )
  if (NOT MSVC)
    add_definitions( "-fPIC" )
  endif()
endif()

#-- OpenScenegraph -----------------------------------------
if ( SFCGAL_WITH_OSG )
  find_package( OpenSceneGraph COMPONENTS osgDB osgUtil )
  if( ${OPENSCENEGRAPH_FOUND} )
    message( STATUS "OPENSCENEGRAPH_INCLUDE_DIRS = ${OPENSCENEGRAPH_INCLUDE_DIRS}" )
    message( STATUS "OPENSCENEGRAPH_LIBRARIES = ${OPENSCENEGRAPH_LIBRARIES}" )

    include_directories( SYSTEM ${OPENSCENEGRAPH_INCLUDE_DIRS} )
  endif()
endif()

#-- note that SYSTEM turns -I/path to -isystem and avoid warnings in CGAL and Boost
include_directories( SYSTEM
	${CGAL_INCLUDE_DIRS}
	${Boost_INCLUDE_DIRS}
)
link_directories(
	${CGAL_LIBRARY_DIRS}
	${Boost_LIBRARY_DIRS}
)

#-- Coverage ---------------------------------------------------------------------
option( SFCGAL_COVERAGE "Generate code coverage report" OFF)
if( SFCGAL_COVERAGE )
include(CodeCoverage)
append_coverage_compiler_flags()
set(COVERAGE_EXCLUDES
  '${PROJECT_SOURCE_DIR}/CGAL/*'
  '${PROJECT_SOURCE_DIR}/test/*')
setup_target_for_coverage_gcovr_xml(
     NAME sfcgal_coverage                    # New target name
     EXECUTABLE ctest -j ${PROCESSOR_COUNT} -R unit-test
     DEPENDENCIES SFCGAL unit-test-SFCGAL
     )
endif()

#-- Warnings, frounding-math and gprof  ------------------------------------------
option( SFCGAL_WARNING_AS_ERROR "fail the build on warnings" OFF )
option( SFCGAL_BUILD_WITH_GPROF "build with gprof" OFF )
if(MSVC)
	# Force to always compile with W4
	if(CMAKE_CXX_FLAGS MATCHES "/W[0-4]")
		string(REGEX REPLACE "/W[0-4]" "/W4" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
	else()
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4")
	endif()
elseif(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX)
	# Update if necessary
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wno-long-long -pedantic -Wpointer-arith -Wcast-align -Wcast-qual -Wno-overloaded-virtual -Wformat=2 -Winit-self -Wmissing-include-dirs -Wwrite-strings -Wno-error=undef")#-Wfloat-equal -Wconversion -Wshadow
    if( SFCGAL_WARNING_AS_ERROR )
		 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror -Wno-error=format")
	endif()

	# Allows profiling with gprof
	if(SFCGAL_BUILD_WITH_GPROF)
		set(CMAKE_EXE_LINKER_FLAGS_DEBUG "-pg")
	endif()
endif()


if(NOT DEFINED CMAKE_INSTALL_LIBDIR)
  set(_LIBDIR_DEFAULT "lib")
  # Override this default 'lib' with 'lib64' iff:
  #  - we are on Linux system but NOT cross-compiling
  #  - we are NOT on debian
  #  - we are on a 64 bits system
  # reason is: amd64 ABI: http://www.x86-64.org/documentation/abi.pdf
  # Note that the future of multi-arch handling may be even
  # more complicated than that: http://wiki.debian.org/Multiarch
  if(CMAKE_SYSTEM_NAME MATCHES "Linux"
      AND NOT CMAKE_CROSSCOMPILING
      AND NOT EXISTS "/etc/debian_version")
    if(NOT DEFINED CMAKE_SIZEOF_VOID_P)
      message(AUTHOR_WARNING
        "Unable to determine default CMAKE_INSTALL_LIBDIR directory because no target architecture is known. "
        "Please enable at least one language before including GNUInstallDirs.")
    else()
      if("${CMAKE_SIZEOF_VOID_P}" EQUAL "8")
        set(_LIBDIR_DEFAULT "lib64")
      endif()
    endif()
  endif()
  set(CMAKE_INSTALL_LIBDIR "${_LIBDIR_DEFAULT}" CACHE PATH "object code libraries (${_LIBDIR_DEFAULT})")
endif()

SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
#SET(CMAKE_MACOSX_RPATH ON)

#-- generate library headers
configure_file( ${CMAKE_SOURCE_DIR}/src/config.h.cmake include/SFCGAL/config.h )
configure_file( ${CMAKE_SOURCE_DIR}/src/version.h.cmake include/SFCGAL/version.h )

enable_testing()

#note : not available on windows without export/import
OPTION( SFCGAL_USE_STATIC_LIBS "define if SFCGAL is build as a static library" OFF )

#-- build the library
add_subdirectory( src )

#-- build test (todo only if boost use dyn link)
add_subdirectory( test )

#-- build examples
if( SFCGAL_BUILD_EXAMPLES )
	add_subdirectory( example )
endif()

#-- doxygen documentation (allows make doc when doxygen is found)
if( SFCGAL_BUILD_DOC )
  add_subdirectory( doc )
endif()

#-- install directories
install(DIRECTORY ${CMAKE_BINARY_DIR}/include DESTINATION .)


#-- sfcgal-config
if ( "${CMAKE_BUILD_TYPE}" STREQUAL "Debug" )
  set( SFCGAL_LIB_NAME "SFCGAL${CMAKE_DEBUG_POSTFIX}" )
else()
  set( SFCGAL_LIB_NAME "SFCGAL" )
endif()
#set( SFCGAL_LIB_NAME ${${CMAKE_BUILD_TYPE}
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/sfcgal-config.in ${CMAKE_CURRENT_BINARY_DIR}/sfcgal-config @ONLY)
install( PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/sfcgal-config DESTINATION bin )

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/sfcgal.pc.in ${CMAKE_CURRENT_BINARY_DIR}/sfcgal.pc @ONLY)
install( FILES ${CMAKE_CURRENT_BINARY_DIR}/sfcgal.pc DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")

=== src/CMakeLists.txt ===
file( GLOB_RECURSE SFCGAL_SOURCES "*.cpp" )
file( GLOB_RECURSE SFCGAL_HEADERS "*.h" )

if (${CMAKE_CXX_COMPILER_ID} STREQUAL MSVC )
    list(REMOVE_ITEM SFCGAL_SOURCES ${CMAKE_SOURCE_DIR}/src/algorithm/alphaShapes.cpp)
    list(REMOVE_ITEM SFCGAL_HEADERS ${CMAKE_SOURCE_DIR}/src/algorithm/alphaShapes.h)
endif()

file( GLOB_RECURSE SFCGAL_HEADERS_COPIED RELATIVE ${CMAKE_SOURCE_DIR}/src "*.h" )
add_custom_target(copy)
foreach (header ${SFCGAL_HEADERS_COPIED})
    add_custom_command(TARGET copy
        COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_SOURCE_DIR}/src/${header} ${CMAKE_BINARY_DIR}/include/SFCGAL/${header} DEPENDS ${CMAKE_SOURCE_DIR}/src/${header})
endforeach()

set( SFCGAL_OSG_HEADERS
  ${CMAKE_SOURCE_DIR}/src/io/osg.h
  ${CMAKE_SOURCE_DIR}/src/detail/io/OsgFactory.h )
set( SFCGAL_OSG_SOURCES
  ${CMAKE_SOURCE_DIR}/src/io/osg.cpp
  ${CMAKE_SOURCE_DIR}/src/detail/io/OsgFactory.cpp )
message( STATUS "removing OSG dependencies from the library")
list(REMOVE_ITEM SFCGAL_HEADERS ${SFCGAL_OSG_HEADERS})
list(REMOVE_ITEM SFCGAL_SOURCES ${SFCGAL_OSG_SOURCES})

if( SFCGAL_USE_STATIC_LIBS )
  add_definitions( "-DSFCGAL_USE_STATIC_LIBS" )
  if (NOT MSVC)
    add_definitions( "-fPIC" )
  endif()
  add_library(
    SFCGAL
    ${SFCGAL_HEADERS}
    ${SFCGAL_SOURCES}
    )

else()
  add_definitions( "-DSFCGAL_BUILD_SHARED" )
  add_library(
    SFCGAL SHARED
    ${SFCGAL_HEADERS}
    ${SFCGAL_SOURCES}
    )
endif()

add_dependencies( SFCGAL copy )

# set VERSION and SOVERSION
set_target_properties( SFCGAL PROPERTIES VERSION ${SFCGAL_VERSION}
                                         SOVERSION ${SFCGAL_VERSION_MAJOR} )

target_link_libraries( SFCGAL CGAL::CGAL CGAL::CGAL_Core)

if( CGAL_USE_GMPXX )
target_link_libraries( SFCGAL gmpxx )
endif()

target_link_libraries( SFCGAL ${Boost_LIBRARIES} )

if ( ${Use_precompiled_headers} )
  if(PCHSupport_FOUND)
    # Add "-fPIC" for shared library build
    if( ${SFCGAL_USE_STATIC_LIBS} )
      set( pch_option "" )
    else()
      set( pch_option "-fPIC" )
    endif()
    add_precompiled_header(SFCGAL
      include/CGAL/all.h
      ${pch_option}
      )
  endif()
endif()

# install library
install(
	TARGETS
	SFCGAL
	RUNTIME DESTINATION bin
	LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
	ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
	BUNDLE DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

# SFCGAL-osg
if ( SFCGAL_WITH_OSG )
  if( SFCGAL_USE_STATIC_LIBS )
    add_definitions( "-DSFCGAL_USE_STATIC_LIBS" )
    if (NOT MSVC)
      add_definitions( "-fPIC" )
    endif()
    add_library(
      SFCGAL-osg
      ${SFCGAL_OSG_HEADERS}
      ${SFCGAL_OSG_SOURCES}
      )

  else()
    add_definitions( "-DSFCGAL_BUILD_SHARED" )
    add_library(
      SFCGAL-osg SHARED
      ${SFCGAL_OSG_HEADERS}
      ${SFCGAL_OSG_SOURCES}
      )
  endif()
  target_link_libraries( SFCGAL-osg
    SFCGAL
    ${OPENSCENEGRAPH_LIBRARIES}
  )
  set_target_properties( SFCGAL-osg PROPERTIES VERSION ${SFCGAL_VERSION}
                                         SOVERSION ${SFCGAL_VERSION_MAJOR} )
  install(
	TARGETS
	SFCGAL-osg
	RUNTIME DESTINATION bin
	LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
	ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
	BUNDLE DESTINATION ${CMAKE_INSTALL_LIBDIR}
   )
endif()

=== example/SFCGAL-building/CMakeLists.txt ===
GET_FILENAME_COMPONENT( EXAMPLE_NAME ${CMAKE_CURRENT_SOURCE_DIR} NAME )
add_executable( example-${EXAMPLE_NAME} 
	main.cpp 
)

find_package(Boost REQUIRED COMPONENTS serialization)
target_link_libraries( example-${EXAMPLE_NAME} SFCGAL ${Boost_LIBRARIES} SFCGAL-osg)
set_target_properties( example-${EXAMPLE_NAME} PROPERTIES DEBUG_POSTFIX "d" )
install( TARGETS example-${EXAMPLE_NAME} DESTINATION bin )

=== test/regress/CMakeLists.txt ===
#-- standalone test
add_subdirectory( standalone )

#-- test that needs parameters
add_subdirectory( polygon_triangulator )
add_subdirectory( convex_hull )

=== test/unit/CMakeLists.txt ===
#-- build unit tests

find_package(Boost REQUIRED COMPONENTS unit_test_framework serialization)

if( SFCGAL_USE_STATIC_LIBS )
  add_definitions( "-DSFCGAL_USE_STATIC_LIBS" )
endif()

file( GLOB_RECURSE SFCGAL_UNIT_TEST_SOURCES *.cpp )

if (${CMAKE_CXX_COMPILER_ID} STREQUAL MSVC )
    list(REMOVE_ITEM SFCGAL_UNIT_TEST_SOURCES ${CMAKE_SOURCE_DIR}/test/unit/SFCGAL/algorithm/AlphaShapesTest.cpp)
endif()

add_executable( unit-test-SFCGAL ${SFCGAL_UNIT_TEST_SOURCES} )
target_link_libraries( unit-test-SFCGAL SFCGAL)
target_link_libraries(unit-test-SFCGAL ${CGAL_3RD_PARTY_LIBRARIES} ${Boost_LIBRARIES})

set_target_properties( unit-test-SFCGAL PROPERTIES DEBUG_POSTFIX "d" )
install( TARGETS unit-test-SFCGAL DESTINATION bin )

if (CMAKE_BUILD_TYPE STREQUAL "Debug" )
    add_test( unit-testd ${CMAKE_CURRENT_BINARY_DIR}/unit-test-SFCGALd --auto_start_dbg=y --log_level=all)
else()
    add_test( unit-test ${CMAKE_CURRENT_BINARY_DIR}/unit-test-SFCGAL --auto_start_dbg=y --log_level=all)
endif()

=== debian/changelog ===
sfcgal (2.0.0-1build2) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 06 Aug 2025 17:05:53 +0200

sfcgal (2.0.0-1build1) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 06 Aug 2025 16:55:28 +0200

sfcgal (2.0.0-1) unstable; urgency=medium

  * Update symbols for other architectures.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 12 Oct 2024 11:11:16 +0200

sfcgal (2.0.0-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Update copyright file.
  * Drop cgal6.patch, included upstream.
  * Rename library package for SONAME bump.
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 11 Oct 2024 06:32:39 +0200

=== debian/control ===
Source: sfcgal
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Sven Geggus <sven-debian@geggus.net>,
           Bas Couwenberg <sebastic@debian.org>
Section: science
Priority: optional
Build-Depends: chrpath,
               cmake,
               debhelper-compat (= 13),
               dh-sequence-pkgkde-symbolshelper,
               libcgal-dev (>= 5.3),
               libboost-all-dev,
               libmpfr-dev,
               libgmp-dev,
               pkg-kde-tools
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/debian-gis-team/sfcgal
Vcs-Git: https://salsa.debian.org/debian-gis-team/sfcgal.git
Homepage: http://www.sfcgal.org/
Rules-Requires-Root: no

Package: libsfcgal2
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Library for ISO 19107:2013 and OGC SFA 1.2 for 3D operations
 SFCGAL is a C++ wrapper library around CGAL with the aim of
 supporting ISO 19107:2013 and OGC Simple Features Access 1.2 for 3D
 operations.
 .
 SFCGAL provides standard compliant geometry types and operations,
 that can be accessed from its C or C++ APIs. PostGIS uses the C API,
 to expose some SFCGAL's functions in spatial databases (cf. PostGIS
 manual).
 .
 This package provides the shared library.

Package: libsfcgal-dev
Architecture: any
Section: libdevel
Depends: libsfcgal2 (= ${binary:Version}),
         libcgal-dev (>= 4.10.1),
         libgmp-dev,
         ${misc:Depends}
Description: Library for ISO 19107:2013 and OGC SFA 1.2 for 3D operations (development)
 SFCGAL is a C++ wrapper library around CGAL with the aim of
 supporting ISO 19107:2013 and OGC Simple Features Access 1.2 for 3D
 operations.
 .
 SFCGAL provides standard compliant geometry types and operations,
 that can be accessed from its C or C++ APIs. PostGIS uses the C API,
 to expose some SFCGAL's functions in spatial databases (cf. PostGIS
 manual).
 .
 This package provides the development files.

## sfcgal 2.1.0

=== debian/changelog ===
sfcgal (2.1.0-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.7.2, no changes.
  * Update watch file to get full path to archive download.
  * Update copyright file.
  * Include CMake config scripts in -dev package.
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 15 May 2025 05:39:49 +0200

=== debian/control ===
--- 
+++ 
@@ -13,9 +13,9 @@
                libmpfr-dev,
                libgmp-dev,
                pkg-kde-tools
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/debian-gis-team/sfcgal
-Vcs-Git: https://salsa.debian.org/debian-gis-team/sfcgal.git
+Vcs-Git: https://salsa.debian.org/debian-gis-team/sfcgal.git -b experimental
 Homepage: http://www.sfcgal.org/
 Rules-Requires-Root: no

## sfcgal 2.2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,11 @@
 cmake_minimum_required( VERSION 3.6 )
-project( SFCGAL )
+
+set( SFCGAL_VERSION_MAJOR 2 )
+set( SFCGAL_VERSION_MINOR 2 )
+set( SFCGAL_VERSION_PATCH 0 )
+
+set( SFCGAL_VERSION "${SFCGAL_VERSION_MAJOR}.${SFCGAL_VERSION_MINOR}.${SFCGAL_VERSION_PATCH}" )
+project( SFCGAL VERSION ${SFCGAL_VERSION} )
 
 set( CMAKE_DEBUG_POSTFIX "d" )
 set(CMAKE_CXX_STANDARD 17)
@@ -40,6 +46,8 @@
 option( SFCGAL_BUILD_DOC "Build documentation" OFF )
 
 option( SFCGAL_WITH_OSG "Compile with OpenSceneGraph support" OFF )
+option( SFCGAL_VALGRIND "Compile with Valgrind support" OFF )
+option( SFCGAL_TSAN "Enable ThreadSanitizer (Debug only)" OFF)
 
 # Configure CCache if available
 if(NOT MSVC)
@@ -57,12 +65,6 @@
 #-- include finders and co
 set( CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/Modules;${CMAKE_MODULE_PATH}" )
 
-set( SFCGAL_VERSION_MAJOR 2 )
-set( SFCGAL_VERSION_MINOR 0 )
-set( SFCGAL_VERSION_PATCH 0 )
-
-set( SFCGAL_VERSION "${SFCGAL_VERSION_MAJOR}.${SFCGAL_VERSION_MINOR}.${SFCGAL_VERSION_PATCH}" )
-
 if (CMAKE_CXX_COMPILER MATCHES ".*clang")
     set(CMAKE_COMPILER_IS_CLANGXX 1)
 endif ()
@@ -71,6 +73,22 @@
 # dependencies
 #-----------------------------------------------------------
 
+if( SFCGAL_VALGRIND )
+  # valgrind tends to alter how CGAL works. To avoid the '-frounding-math' warning we need to activate this define:
+  add_definitions( "-DCGAL_DISABLE_ROUNDING_MATH_CHECK" )
+endif()
+
+# Require Debug build if SFCGAL_TSAN is ON
+if ( SFCGAL_TSAN )
+    if (NOT CMAKE_BUILD_TYPE STREQUAL "Debug")
+        message(FATAL_ERROR "SFCGAL_TSAN is enabled but CMAKE_BUILD_TYPE is not Debug. Please configure with -DCMAKE_BUILD_TYPE=Debug")
+    endif()
+
+    message(STATUS "ThreadSanitizer enabled (C & C++)")
+    add_compile_options(-fsanitize=thread -g)
+    add_link_options(-fsanitize=thread)
+endif()
+
 #-- find CGAL  ---------------------------------------------
 if( CGAL_USE_GMPXX )
 	add_definitions( "-DCGAL_USE_GMPXX" )
@@ -84,12 +102,14 @@
 find_package( CGAL 5.6 COMPONENTS Core REQUIRED )
 message( STATUS "CGAL ${CGAL_VERSION} found" )
 
+set(CGAL_3RD_PARTY_LIBRARIES CGAL::CGAL CGAL::CGAL_Core)
+
 include_directories( ${CMAKE_BINARY_DIR}/include )
 
 #-- BOOST --------------------------------------------------
 option( Boost_USE_AUTO_LINK "boost use autolink" OFF )
 set(Boost_USE_DEBUG_RUNTIME OFF)
-set(Boost_USE_STATIC_LIBS OFF)
+# set(Boost_USE_STATIC_LIBS OFF)
 option( Boost_USE_DEBUG_RUNTIME "Use Boost debug runtime" OFF )
 
 if( NOT ${Boost_USE_AUTO_LINK} )
@@ -115,13 +135,9 @@
 
 #-- minimalist build allowed with boost version older than 1.48
 set( SFCGAL_Boost_COMPONENTS thread system serialization )
-#-- unit test
-if ( SFCGAL_BUILD_TESTS )
-	set( SFCGAL_Boost_COMPONENTS unit_test_framework program_options ${SFCGAL_Boost_COMPONENTS} )
-endif()
 #-- program_options
 if ( SFCGAL_BUILD_TESTS OR SFCGAL_BUILD_EXAMPLES OR SFCGAL_BUILD_OSG )
-	set( SFCGAL_Boost_COMPONENTS program_options chrono filesystem timer ${SFCGAL_Boost_COMPONENTS} )
+	set( SFCGAL_Boost_COMPONENTS chrono unit_test_framework filesystem program_options timer ${SFCGAL_Boost_COMPONENTS} )
 endif()
 find_package( Boost COMPONENTS ${SFCGAL_Boost_COMPONENTS} REQUIRED )
 if((${Boost_MAJOR_VERSION} EQUAL 1) AND (${Boost_MINOR_VERSION} EQUAL 58))
@@ -221,7 +237,11 @@
   set(CMAKE_INSTALL_LIBDIR "${_LIBDIR_DEFAULT}" CACHE PATH "object code libraries (${_LIBDIR_DEFAULT})")
 endif()
 
-SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
+if(NOT DEFINED CMAKE_INSTALL_FULL_LIBDIR)
+    set(CMAKE_INSTALL_FULL_LIBDIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
+endif()
+
+SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_FULL_LIBDIR}")
 SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
 #SET(CMAKE_MACOSX_RPATH ON)
 
@@ -260,9 +280,50 @@
 else()
   set( SFCGAL_LIB_NAME "SFCGAL" )
 endif()
+
+if ( UNIX )
+  include(GNUInstallDirs)
+endif()
 #set( SFCGAL_LIB_NAME ${${CMAKE_BUILD_TYPE}
 configure_file(${CMAKE_CURRENT_SOURCE_DIR}/sfcgal-config.in ${CMAKE_CURRENT_BINARY_DIR}/sfcgal-config @ONLY)
 install( PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/sfcgal-config DESTINATION bin )
 
 configure_file(${CMAKE_CURRENT_SOURCE_DIR}/sfcgal.pc.in ${CMAKE_CURRENT_BINARY_DIR}/sfcgal.pc @ONLY)
 install( FILES ${CMAKE_CURRENT_BINARY_DIR}/sfcgal.pc DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")
+
+include(GNUInstallDirs)
+include(CMakePackageConfigHelpers)
+
+set(SFCGAL_INCLUDE_DIR "${CMAKE_INSTALL_INCLUDEDIR}")
+set(SFCGAL_LIBRARY_DIR "${CMAKE_INSTALL_LIBDIR}")
+
+configure_package_config_file(
+    "${CMAKE_CURRENT_SOURCE_DIR}/SFCGALConfig.cmake.in"
+    "${CMAKE_CURRENT_BINARY_DIR}/SFCGALConfig.cmake"
+    INSTALL_DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/SFCGAL"
+    PATH_VARS SFCGAL_INCLUDE_DIR SFCGAL_LIBRARY_DIR
+)
+
+write_basic_package_version_file(
+    "${CMAKE_CURRENT_BINARY_DIR}/SFCGALConfigVersion.cmake"
+    VERSION ${PROJECT_VERSION}
+    COMPATIBILITY SameMajorVersion
+)
+
+install(FILES
+    "${CMAKE_CURRENT_BINARY_DIR}/SFCGALConfig.cmake"
+    "${CMAKE_CURRENT_BINARY_DIR}/SFCGALConfigVersion.cmake"
+    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/SFCGAL"
+)
+
+install(TARGETS SFCGAL
+        EXPORT SFCGALTargets
+        LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
+        ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
+        RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}"
+        INCLUDES DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")
+
+install(EXPORT SFCGALTargets
+        FILE SFCGALTargets.cmake
+        NAMESPACE SFCGAL::
+        DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/SFCGAL")

=== example/CMakeLists.txt ===
add_subdirectory( CGAL-basic_manip )
add_subdirectory( CGAL-cartesian_kernel )
add_subdirectory( CGAL-point_generator )
add_subdirectory( CGAL-triangulation2 )
add_subdirectory( CGAL-polygon_triangulation2 )
add_subdirectory( SFCGAL-offset )

if ( SFCGAL_WITH_OSG )
	add_subdirectory( SFCGAL-export-osg )
	add_subdirectory( SFCGAL-building )
endif()

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -4,6 +4,18 @@
 if (${CMAKE_CXX_COMPILER_ID} STREQUAL MSVC )
     list(REMOVE_ITEM SFCGAL_SOURCES ${CMAKE_SOURCE_DIR}/src/algorithm/alphaShapes.cpp)
     list(REMOVE_ITEM SFCGAL_HEADERS ${CMAKE_SOURCE_DIR}/src/algorithm/alphaShapes.h)
+endif()
+
+if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU" AND
+    CMAKE_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL 15.0 AND
+    CGAL_VERSION VERSION_LESS 6.0.2)
+  set(ALPHAWRAP_SRC ${CMAKE_SOURCE_DIR}/src/algorithm/alphaWrapping3D.cpp)
+  list(FIND SFCGAL_SOURCES  ${ALPHAWRAP_SRC} ALPHA_WRAPPING_INDEX)
+  if (ALPHA_WRAPPING_INDEX GREATER_EQUAL 0)
+    # With inline enabled CGAL::alpha_wrap_3 may segfault with GCC 15
+    # See: https://github.com/CGAL/cgal/issues/8876
+    set_source_files_properties(${ALPHAWRAP_SRC} PROPERTIES COMPILE_OPTIONS "-fno-inline")
+  endif()
 endif()
 
 file( GLOB_RECURSE SFCGAL_HEADERS_COPIED RELATIVE ${CMAKE_SOURCE_DIR}/src "*.h" )
@@ -49,13 +61,16 @@
 set_target_properties( SFCGAL PROPERTIES VERSION ${SFCGAL_VERSION}
                                          SOVERSION ${SFCGAL_VERSION_MAJOR} )
 
-target_link_libraries( SFCGAL CGAL::CGAL CGAL::CGAL_Core)
+target_link_libraries( SFCGAL ${CGAL_3RD_PARTY_LIBRARIES})
 
 if( CGAL_USE_GMPXX )
-target_link_libraries( SFCGAL gmpxx )
+  target_link_libraries( SFCGAL gmpxx )
 endif()
 
 target_link_libraries( SFCGAL ${Boost_LIBRARIES} )
+set_target_properties(SFCGAL PROPERTIES
+  INTERFACE_LINK_LIBRARIES ""
+)
 
 if ( ${Use_precompiled_headers} )
   if(PCHSupport_FOUND)

=== test/CMakeLists.txt ===
#-- configure tests

if( SFCGAL_USE_STATIC_LIBS )
  add_definitions( "-DSFCGAL_USE_STATIC_LIBS" )
endif()

set( SFCGAL_TEST_DIRECTORY "${CMAKE_SOURCE_DIR}/test" )
configure_file( ${SFCGAL_TEST_DIRECTORY}/test_config.h.cmake ${SFCGAL_TEST_DIRECTORY}/test_config.h )

if(CMAKE_COMPILER_IS_GNUCXX)
  add_definitions( "-frounding-math" )
  
endif(CMAKE_COMPILER_IS_GNUCXX)

#-- build regression tests
if( SFCGAL_BUILD_TESTS )
	add_subdirectory( unit )
	add_subdirectory( regress )
endif()

if( SFCGAL_BUILD_BENCH )
	add_subdirectory( bench )
endif()

# add a custom rule "check" that adds verbosity to ctest
add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND} --verbose)

=== example/SFCGAL-export-osg/CMakeLists.txt ===
GET_FILENAME_COMPONENT( EXAMPLE_NAME ${CMAKE_CURRENT_SOURCE_DIR} NAME )
add_executable( example-${EXAMPLE_NAME} 
	main.cpp 
)
find_package(Boost REQUIRED COMPONENTS serialization)
target_link_libraries( example-${EXAMPLE_NAME} SFCGAL SFCGAL-osg ${Boost_LIBRARIES})
set_target_properties( example-${EXAMPLE_NAME} PROPERTIES DEBUG_POSTFIX "d" )
install( TARGETS example-${EXAMPLE_NAME} DESTINATION bin )

=== test/bench/CMakeLists.txt ===
file( GLOB SFCGAL_BENCHS_SOURCES *.cpp )
add_executable( bench-SFCGAL ${SFCGAL_BENCHS_SOURCES} )

find_package(Boost REQUIRED COMPONENTS unit_test_framework timer serialization)

target_link_libraries( bench-SFCGAL SFCGAL ${Boost_LIBRARIES})
set_target_properties( bench-SFCGAL PROPERTIES DEBUG_POSTFIX "d" )
install( TARGETS bench-SFCGAL DESTINATION bin )

=== test/regress/CMakeLists.txt ===
#-- standalone test
add_subdirectory( capi )
add_subdirectory( standalone )

#-- test that needs parameters
add_subdirectory( polygon_triangulator )
add_subdirectory( convex_hull )

=== test/unit/CMakeLists.txt ===
#-- build unit tests
find_package(Boost REQUIRED COMPONENTS ${SFCGAL_Boost_COMPONENTS})
if( SFCGAL_USE_STATIC_LIBS )
  add_definitions( "-DSFCGAL_USE_STATIC_LIBS" )
endif()

# Detect MSYS environment
set(IS_MSYS FALSE)
if(DEFINED ENV{MSYSTEM} OR CMAKE_SYSTEM_NAME MATCHES "MSYS")
  set(IS_MSYS TRUE)
  message(STATUS "MSYS environment detected - disabling sfcgal-config test")
endif()

if(NOT DEFINED SFCGAL_CONFIG_EXECUTABLE)
  if(WIN32)
    set(SFCGAL_CONFIG_EXECUTABLE "${CMAKE_BINARY_DIR}/sfcgal-config.exe")
  else()
    set(SFCGAL_CONFIG_EXECUTABLE "${CMAKE_BINARY_DIR}/sfcgal-config")
  endif()
endif()

# Configure testsfcgalconfig.cpp only if not MSYS
if(NOT IS_MSYS)
  configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/SFCGAL/testsfcgalconfig.cpp.in"
    "${CMAKE_CURRENT_BINARY_DIR}/SFCGAL/testsfcgalconfig.cpp"
    @ONLY
  )
endif()

file(GLOB_RECURSE SFCGAL_UNIT_TEST_SOURCES
     "${CMAKE_CURRENT_SOURCE_DIR}/*.cpp"
)

# Add testsfcgalconfig.cpp only if not MSYS and file exists
if(NOT IS_MSYS AND EXISTS "${CMAKE_CURRENT_BINARY_DIR}/SFCGAL/testsfcgalconfig.cpp")
  list(APPEND SFCGAL_UNIT_TEST_SOURCES "${CMAKE_CURRENT_BINARY_DIR}/SFCGAL/testsfcgalconfig.cpp")
endif()

if (${CMAKE_CXX_COMPILER_ID} STREQUAL MSVC )
    list(REMOVE_ITEM SFCGAL_UNIT_TEST_SOURCES ${CMAKE_SOURCE_DIR}/test/unit/SFCGAL/algorithm/AlphaShapesTest.cpp)
endif()

add_executable( unit-test-SFCGAL ${SFCGAL_UNIT_TEST_SOURCES} )
target_link_libraries( unit-test-SFCGAL SFCGAL)
target_link_libraries(unit-test-SFCGAL ${CGAL_3RD_PARTY_LIBRARIES} ${Boost_LIBRARIES})
set_target_properties( unit-test-SFCGAL PROPERTIES DEBUG_POSTFIX "d" )
if (CMAKE_BUILD_TYPE STREQUAL "Debug" )
    add_test( unit-testd ${CMAKE_CURRENT_BINARY_DIR}/unit-test-SFCGALd --auto_start_dbg=y --log_level=all)
else()
    add_test( unit-test ${CMAKE_CURRENT_BINARY_DIR}/unit-test-SFCGAL --auto_start_dbg=y --log_level=all)
endif()

=== test/regress/capi/CMakeLists.txt ===
#-- capi test

if( SFCGAL_USE_STATIC_LIBS )
  add_definitions( "-DSFCGAL_USE_STATIC_LIBS" )
endif()

file( GLOB_RECURSE SFCGAL_REGRESS_POLYGON_TRIANGULATOR_TEST_SOURCES *.c )

set( REGRESS_NAME test-regress-capi )
add_executable( ${REGRESS_NAME} ${SFCGAL_REGRESS_POLYGON_TRIANGULATOR_TEST_SOURCES} )

find_package(Boost REQUIRED COMPONENTS ${SFCGAL_Boost_COMPONENTS})

target_link_libraries( ${REGRESS_NAME}	SFCGAL)


set_target_properties( ${REGRESS_NAME} PROPERTIES DEBUG_POSTFIX "d" )

=== test/regress/convex_hull/CMakeLists.txt ===
#-- polygon_triangulator test

if( SFCGAL_USE_STATIC_LIBS )
  add_definitions( "-DSFCGAL_USE_STATIC_LIBS" )
endif()

file( GLOB_RECURSE SFCGAL_REGRESS_CONVEX_HULL_TEST_SOURCES *.cpp )

set( REGRESS_NAME test-regress-convex_hull )
add_executable( ${REGRESS_NAME} ${SFCGAL_REGRESS_CONVEX_HULL_TEST_SOURCES} )

find_package(Boost REQUIRED COMPONENTS ${SFCGAL_Boost_COMPONENTS})

target_link_libraries( ${REGRESS_NAME} SFCGAL)

target_link_libraries( ${REGRESS_NAME} ${CGAL_3RD_PARTY_LIBRARIES} ${Boost_LIBRARIES})

set_target_properties( ${REGRESS_NAME} PROPERTIES DEBUG_POSTFIX "d" )

=== test/regress/standalone/CMakeLists.txt ===
#-- standalone test

if( SFCGAL_USE_STATIC_LIBS )
  add_definitions( "-DSFCGAL_USE_STATIC_LIBS" )
endif()

file( GLOB_RECURSE SFCGAL_REGRESS_STANDALONE_TEST_SOURCES *.cpp )
add_executable( standalone-regress-test-SFCGAL ${SFCGAL_REGRESS_STANDALONE_TEST_SOURCES} )

find_package(Boost REQUIRED COMPONENTS ${SFCGAL_Boost_COMPONENTS})

target_link_libraries( standalone-regress-test-SFCGAL SFCGAL ${CGAL_3RD_PARTY_LIBRARIES} ${Boost_LIBRARIES})

set_target_properties( standalone-regress-test-SFCGAL PROPERTIES DEBUG_POSTFIX "d" )

if (CMAKE_BUILD_TYPE STREQUAL "Debug" )
    add_test( standalone-regress-testd ${CMAKE_CURRENT_BINARY_DIR}/standalone-regress-test-SFCGALd --auto_start_dbg=y --log_level=all)
else()
    add_test( standalone-regress-test ${CMAKE_CURRENT_BINARY_DIR}/standalone-regress-test-SFCGAL --auto_start_dbg=y --log_level=all)
endif()

=== debian/changelog ===
sfcgal (2.2.0-2) unstable; urgency=medium

  * Update lintian overrides.
  * Drop Rules-Requires-Root: no, default since dpkg 1.22.13.
  * Use test-build-validate-cleanup instead of test-build-twice.
  * Use debrebuild instead of reprotest.
  * Drop dh_auto_test override.
  * Drop Priority: optional, default since dpkg 1.22.13.
  * Bump Standards-Version to 4.7.3, changes: priority.
  * Replace libboost-all-dev build dependency with only required ones.
  * Add upstream patch to fix FTBFS with Boost 1.89.
    (closes: #1128145)
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 04 Mar 2026 12:10:20 +0100

sfcgal (2.2.0-1) unstable; urgency=medium

  * Update symbols for other architectures.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 10 Aug 2025 10:29:15 +0200

sfcgal (2.2.0-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Mark libsfcgal2 as Multi-Arch: same.
  * Update copyright file.
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 01 Aug 2025 06:16:42 +0200

=== debian/control ===
--- 
+++ 
@@ -3,24 +3,29 @@
 Uploaders: Sven Geggus <sven-debian@geggus.net>,
            Bas Couwenberg <sebastic@debian.org>
 Section: science
-Priority: optional
 Build-Depends: chrpath,
                cmake,
                debhelper-compat (= 13),
                dh-sequence-pkgkde-symbolshelper,
                libcgal-dev (>= 5.3),
-               libboost-all-dev,
+               libboost-chrono-dev,
+               libboost-filesystem-dev,
+               libboost-program-options-dev,
+               libboost-serialization-dev,
+               libboost-test-dev,
+               libboost-thread-dev,
+               libboost-timer-dev,
                libmpfr-dev,
                libgmp-dev,
                pkg-kde-tools
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Vcs-Browser: https://salsa.debian.org/debian-gis-team/sfcgal
-Vcs-Git: https://salsa.debian.org/debian-gis-team/sfcgal.git -b experimental
+Vcs-Git: https://salsa.debian.org/debian-gis-team/sfcgal.git
 Homepage: http://www.sfcgal.org/
-Rules-Requires-Root: no
 
 Package: libsfcgal2
 Architecture: any
+Multi-Arch: same
 Section: libs
 Depends: ${shlibs:Depends},
          ${misc:Depends}

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk

UPSTREAM_VERSION=$(shell echo $(DEB_VERSION_UPSTREAM) | sed -e 's/\+.*//')

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

# reduce debug info to fix FTBFS on archs with few address space
ifneq (,$(filter $(DEB_HOST_ARCH),arm64 armhf ppc64el))
    CMAKECXXFLAGS="-DCMAKE_CXX_FLAGS_RELWITHDEBINFO=' -O2 -g1 -DNDEBUG'"
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		$(CMAKECXXFLAGS) \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DCMAKE_INSTALL_LIBDIR=lib/$(DEB_HOST_MULTIARCH) \
		-DCMAKE_VERBOSE_MAKEFILE=ON \
		-DSFCGAL_BUILD_TESTS=ON

execute_before_dh_install:
	# removing embedded rpath in binaries
	-find $(CURDIR)/debian/tmp/usr/bin -type f -not -name sfcgal-config -exec chrpath --delete {} \;

	# removing embedded rpath in libraries
	-find $(CURDIR)/debian/tmp/usr/lib -name "*.so*" -type f -exec chrpath --delete {} \;

	# Remove test executables
	$(RM) $(CURDIR)/debian/tmp/usr/bin/*test*

override_dh_installchangelogs:
	dh_installchangelogs NEWS
	
override_dh_makeshlibs:
	dh_makeshlibs -- -c0 -v$(UPSTREAM_VERSION)
